<?php

namespace Cursed\Screen\Component;

use Cursed\Screen\Screen;
use Cursed\Screen\Renderable;

class StatusBar implements Renderable
{
    public ?string $message = null;

    public array $hotkeys = [];

    public string $preKey = "\e[2m\u{e0b6}\e[7m";

    public string $postKey = "\e[27m\u{e0b4}\e[22m";

    public function render(Screen $screen, array $options = []): void
    {
        $width = $screen->columns;
        $output = [ "\e[0;37;40m" ];
        foreach ($this->hotkeys as $key=>$info) {
            $length = mb_strlen($key) + mb_strlen($info) + 5;
            if ($width > $length) {
                $key = $this->preKey . $key . $this->postKey;
                $tag = sprintf(" %s \e[3m%s\e[23m ", $key, $info);
                $output[] = $tag;
                $taglen = mb_strlen(preg_replace('/\e\[(.+?)m/', '', $tag));
                $width -= $taglen;
            } else break;
        }
        $output[] = "\e[K\e[0m";
        $screen->writeAt(0, -1, join("", $output));
    }
}
